from djitellopy import Tello
import time
import matplotlib.pyplot as plt
import concurrent.futures
import threading

import datetime # To monitor time
#now = datetime.datetime.now()

Ts = 0.1
RC_Z = RC_YAW = 0
seuil = 5
Z = YAW = 0

VRR = 100

Validation = False
Registering = True
Controling = True

file_name = "dataCL_Tello.txt"
file_name_sampling = "dataCL_Tello_sampling.txt"


#################################
##          Functions          ##
#################################

def check(delay):
    global Validation
    while Controling == True:
        time.sleep(delay)
        Validation = True

def go_to_position(waypoints):
    """Go to z coordinates and check that Z is around the wanted value"""

    print("going to position")
    # K = 
    # T =

    # D1 = 0.043
    z = 0.707
    Tr = 2
    w0 = 3/Tr

    global RC_Z, VRR, Z, Controling, Validation

  ####       Enter the P gain value below       ###

    kp = 1.2


    # U_kd_km1 = 0 # Ukd(k-1)
    
    point_index = 0

    while point_index < len(waypoints):
            ############ Z ############
        Z = waypoints[point_index][2] # Setpoint for the altitude or vertical position along the Z axis

        Zm = tello.get_distance_tof() # Measured altitude or vertical position along the Z axis

        e_z = Z - Zm # Altitude error

        # Update of the control
        U_kp = kp * e_z  # proportional control

        U_kd = 0	 # derivative control
 
        # Compute command
        rc_z = U_kp + U_kd
 
       # Save altitude at time k minus 1 (k-1)
        U_kd_km1 = U_kd

            ###########################
        
        # print("e_z: " + str(e_z) + "\n")

        rc_z = int(saturation(rc_z, -100, 100))

        RC_Z = rc_z
        
        VRR = e_z

        if Validation == True:
            point_index += 1
            Validation = False

        time.sleep(Ts)
        #now = datetime.datetime.now()
        #print("time" + str(now))
    
def send_rc():
    while Controling == True:
        tello.send_rc_control(0, 0, RC_Z, RC_YAW)
        time.sleep(Ts)

def saturation(val, min, max):
    if val > max:
        val = max
    elif val < min:
        val = min
    return val

def register(start_time):
    print("Registering\n")
    result = open(file_name,"w")
    global RC_Z, Z

    while Registering == True:
        instant_time = time.time() - start_time
 
        result.write(str(instant_time) + " " + str(tello.get_distance_tof()) + " " + str(RC_Z) + " " + str(Z) + " " + str(-tello.get_speed_z()*10) +"\n")        
        time.sleep(Ts)
    
    result.close()
    
    print("Done registering")



##############################
##          Control         ##
##############################



tello = Tello()
tello.connect()

print("battery: " + str(tello.get_battery()) + "%")

time.sleep(3)

######################################
##      Closed Loop - Beginning     ## 

with concurrent.futures.ThreadPoolExecutor() as executor:
    delay = 5 # Period of the input step signal in seconds
    start_time = time.time()
    
    executor.map(register, [start_time])  

    tello.takeoff()

    time.sleep(3)

    waypoints = [[0, 0, 100, 0],
                 [0, 0, 150, 0],
                 [0, 0, 100, 0],
                 [0, 0, 150, 0],
                 [0, 0, 100, 0],
                 [0, 0, 150, 0]] ## Input steps


    executor.submit(send_rc)
    executor.map(check, [delay])
    
    go_to_position(waypoints)
    

    Controling = False
    running_check = False

    time.sleep(1)

    tello.send_rc_control(0,0,0,0)



    time.sleep(3)
    
    RC_Z = 0
    time.sleep(1)
    tello.land()

    Registering = False

##      Closed Loop - End           ## 
######################################

############################
##          Plot          ##
############################

time.sleep(1) 

fichier = open(file_name,"r")

Time = []
ToF = []
cmd = []
consign = []
speed = []
for ligne in fichier:
    valeurs = ligne.split()
    Time.append(float(valeurs[0]))
    ToF.append(float(valeurs[1]))
    cmd.append(float(valeurs[2]))
    consign.append(float(valeurs[3]))
    speed.append(float(valeurs[4]))

fichier.close()

plt.plot(Time, ToF)
plt.plot(Time, cmd)
plt.plot(Time, consign)
plt.plot(Time, speed)

plt.xlabel('Temps')
plt.legend(["altitude","commande","consigne","vitesse sur l'axe Z"])
plt.show()

    